local ForceUseBackupClass=false;

local locale=GetLocale();
local loadbackupclasses=false;
local lib;

--XBarLocalizerCache = {};

-- This code provides a generalized interface in which to retrieve localizations from Babble.
lib=LibStub:GetLibrary("LibBabble-Class-3.0",1);
if not lib then
	if not ForceUseBackupClass then
		DEFAULT_CHAT_FRAME:AddMessage("XBarLocalizer: LibBabble-Class failed to load.");
	end
else
	XBarLocalizerLBC=lib:GetLookupTable();
end

-- Set this so mods can see if we're loaded or not
XBARLOCALIZER = true;

if (locale ~= "enUS" and locale ~= "enGB") and XBarLocalizerLBC==nil then
	-- If not using enUS or enGB, load the backup db
	loadbackupclasses=true;
end

if ForceUseBackupClass then
	XBarLocalizerLBC=nil;
	loadbackupclasses=true;
end

if loadbackupclasses then
	XBar_LoadBackupClasses();
end

function XBarGetBackupClass(classname)
	local r=nil;
	
	if (XBarBackupDBClasses) and (XBarBackupDBClasses[locale]) then
		r=XBarBackupDBClasses[locale][skill];
	end

	return r;
end

function XBar_BabbleSpell(text)
	local r=text;
	local i;

	if LibXSpellID then
		i=LibXSpellID.ID[text];
		if i then
			r=GetSpellInfo(LibXSpellID.ID[text]);
		else
			print("XBarLocalizer: Error, no info for '"..text.."', id="..tostring(i));
		end
	end

	-- if we don't have it, just return the same value given
	if r==nil then
		r=text;
	end
	
	return r;
end

function XBar_BabbleClass(text)
	local r=text;

	if XBarLocalizerLBC==nil then
		r=XBarGetBackupClass(text);
	else
		r=XBarLocalizerLBC[text];
	end

	-- if we don't have it, just return the same value given
	if r==nil then
		r=text;
	end
	
	return r;
end

function XBar_BabbleTrade(text)
	local r=text;
	local i;

	if LibXSpellID then
		i=LibXSpellID.ID[text];
		if i then
			r=GetSpellInfo(LibXSpellID.ID[text]);
		else
			print("XBarLocalizer: Error, no info for '"..text.."'");
		end
	end

	-- if we don't have it, just return the same value given
	if r==nil then
		r=text;
	end
	
	return r;
end

--XBarLocalizerCache=LibXSpellID.UpdateList();
--for i,v in pairs(XBarLocalizerCache) do
--	print(i,v);
--end

function XBar_LocalizeList(spelllist)
	local i,v,c;

	-- Auto-translate the spells
	for i,v in pairs(spelllist) do
		c=strsub(spelllist[i],1,1);
		if c~=XBAR_SWRAP and c~="#" and c~=XBAR_SNOWRAP then
			spelllist[i]=XBar_BabbleSpell(spelllist[i]);
		end
	end
end
