local addonName = "XBar"

if not cyCircled.modules["XBar"] then

cyCircled_XBar = cyCircled:NewModule(addonName)

function cyCircled_XBar:AddonLoaded()
	self.db = cyCircled:AcquireDBNamespace(addonName)
	cyCircled:RegisterDefaults(addonName, "profile", {
		["Aspect"] = true,
	})
	
	self:SetupElements()
	self:OnEnable()

	local n,i,bn;
	n=XBarData[XBarCore.XBarOptionSet]["nmods"];
	if (n) and n>0 then
		for i=1,n do
			bn=XBarData[XBarCore.XBarOptionSet]["mod"..i];
			if (XBarCore.ModData[bn]) and (XBarCore.ModData[bn]["enabled"]) then
				XBarCore.Update(bn);
			end
		end
	end
end

function cyCircled_XBar:GetElements()
	local rt={};
	local i,n,bn;
	
	n=XBarData[XBarCore.XBarOptionSet]["nmods"];
	if (n) and n>0 then
		for i=1,n do
			bn=XBarData[XBarCore.XBarOptionSet]["mod"..i];
			if (XBarCore.ModData[bn]) and (XBarCore.ModData[bn]["enabled"]) then
				rt[bn]=true;
			end
		end
	else
		return {};
	end

	return rt;
end

function cyCircled_XBar:SetupElements()
	local rt={};
	local i,n,b,c,m;
	
	n=XBarData[XBarCore.XBarOptionSet]["nmods"];
	if (n) and n>0 then
		for i=1,n do
			m=XBarData[XBarCore.XBarOptionSet]["mod"..i];
			if XBarCore.ModData[m] and XBarCore.ModData[m]["loaded"] then
				rt[m]={
					args = {
						button = { width = 28, height = 28, },
						nt = false,
						ht = true,
						pt = true,
						ct = false,
						ft = false,
						icon=true,
						hotkey=false,
						count = true,
						cooldown=true,
						hotkey = false,
						eborder = false,
						autocast=false,
					},
					elements = {},
				}
				b=XBarCore.ModData[m]["nbuttons"];
				if (b) and (b>0) then
					for c=1,b do
						tinsert(rt[m].elements, format(m.."Button%d", c));
					end
				end
			end
		end
	else
		rt={};
	end

	self.elements=rt;
end
end
