--This is the internal name of the mod.
local XBARMOD="XPetStuffBar";
local dbver="3";

--Default settings and other info about the mod
XBarCore.ModData[XBARMOD] = {
	["nbuttons"]=0,
	["dbver"]=dbver,
	["dhorizontal"]=true,
	["hidebar"]=false,
	["dorder"]="az",
	["dscale"]=1,
	["dtooltips"]=true,
	["enabled"]=false,
	["nchecks"]=0,
	["wrappable"]=false,
	["sortable"]=true,
	["fbuttonid"]="XBar_StdButtonID",
	["fbuttoncb"]="XBar_StdButtonCB",
	["foptioncb"]=XBARMOD.."_OptionCB",
};

XBarCore.ModData.XPetStuffXP={
	["loaded"]=true,
};
local XPETSTUFFXPSETUP=false;

function XPetStuffBar_OnLoad()
	--Each bar must catch its own event notifications
	local Class,_;

	-- Nonlocalized class check
	_, Class = UnitClass("player");
	if (Class == "HUNTER") then
		this:RegisterEvent("SPELLS_CHANGED");
		this:RegisterEvent("SPELL_UPDATE_COOLDOWN");
		this:RegisterEvent("PLAYER_ENTERING_WORLD");
		this:RegisterEvent("ACTIONBAR_UPDATE_USABLE");
		this:RegisterEvent("UNIT_PET_EXPERIENCE");
		this:RegisterEvent("UNIT_PET");
		XBarCore.ModData[XBARMOD].enabled=true;
	else
		this:SetScript("OnUpdate",nil);
		-- Reduces lag
	end
end

function XPetStuffBar_OnEvent(event,arg1)
	-- XPetStuffBar has some stuff it has to do after XBar is done with it
	XBar_StdEventHandler(XBARMOD,event,arg1);
	if (event == "PLAYER_ENTERING_WORLD") then
		XPetStuffXPBar_Setup(self);
		XPetStuffXPBar_UpdateScreen();
		XPetStuffXPBar_Update();
	elseif (event == "UNIT_PET_EXPERIENCE") then
		XPetStuffXPBar_Update();
	elseif (event == "UNIT_PET" and arg1=="player") then
		XPetStuffXPBar_Update();
	end
end

function XPetStuffBar_OptionCB(option,value)
	if (option=="XPBar") then
		XPetStuffXPBar_UpdateScreen();
	else
		XBar_Update(XBARMOD);
	end
end

function XPetStuffXPBar_Setup()
	if not XPETSTUFFXPSETUP then

		TextStatusBar_Initialize(XPetStuffXPBar);
		SetTextStatusBarText(XPetStuffXPBar, XPetStuffXPBarText);
		XBarCore.FrameDB.XPetStuffXPBar={};
		if not XBarData[XBarCore.XBarOptionSet].mods.XPetStuffXP then
			XBarData[XBarCore.XBarOptionSet].mods.XPetStuffXP=
			{
				["x"]=150,
				["y"]=-130,
				["rp"]="TOPLEFT",
				["pt"]="TOPLEFT",
				["hidebar"]=false;
			};
		end
		XBarCore.SetPos("XPetStuffXP");
	end
end

function XPetStuffXPBar_Update()
	local currXP, nextXP = GetPetExperience();

	XPetStuffXPBar:SetMinMaxValues(min(0, currXP), nextXP);
	XPetStuffXPBar:SetValue(currXP);
end

function XPetStuffXPBar_UpdateScreen()
	local value=XBarData[XBarCore.XBarOptionSet].mods.XPetStuffBar.XPBar;
	local v;

	if value then
		v=2; -- Show
	else
		v=1; -- Hide
	end
	XBarCore.ShowHide("XPetStuffXP",v);
end
